use std::error::Error;

use tokio::{io::AsyncReadExt, net::TcpStream};

#[derive(PartialEq, Eq, Debug)]
pub struct Requests {}

impl Requests {
    pub async fn make_request(&self, target: String) -> Result<String, Box<dyn Error>> {
        
        let tasks = tokio::spawn(async {
            let mut buf: String = String::from("");

            let mut stream = match TcpStream::connect(target).await {
                Ok(stream) => stream,
                Err(err) => return Err(Box::new(err)),
            };
            // Buffer to read HTTP request into
            let _ = stream.read_to_string(&mut buf);

            Ok(buf)
        });

        let buf = tasks.await??;

        Ok(buf)
    }
}
